cp ../../../src/parser.mly ./parser.mly

cat ../pass/_assign_parser.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_assign_parser.res
diff ../pass/_assign_parser.out ../pass/_assign_parser.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "|       PARSER: ASSIGN TEST PASSED      |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "|       PARSER: ASSIGN TEST FAILED      |"
  echo "-----------------------------------------"
fi

cat ../pass/_print_parser.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_print_parser.res
diff ../pass/_print_parser.out ../pass/_print_parser.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "|       PARSER: PRINT TEST PASSED       |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "|       PARSER: PRINT TEST FAILED       |"
  echo "-----------------------------------------"
fi

cat ../pass/_main_with_return_parser.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_main_with_return_parser.res
diff ../pass/_main_with_return_parser.out ../pass/_main_with_return_parser.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "| PARSER: MAIN WITH RETURN PASSED       |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "| PARSER: MAIN WITH RETURN PASSED       |"
  echo "-----------------------------------------"
fi


cat ../pass/_fun1_parser.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_fun1_parser.res
diff ../pass/_fun1_parser.out ../pass/_fun1_parser.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "| PARSER: FUNCTION ONE TEST PASSED      |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "| PARSER: FUNCTION ONE TEST FAILED      |"
  echo "-----------------------------------------"
fi

cat ../pass/_fun2_parser.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_fun2_parser.res
diff ../pass/_fun2_parser.out ../pass/_fun2_parser.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "| PARSER: FUNCTION TWO TEST PASSED      |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "| PARSER: FUNCTION TWO TEST FAILED      |"
  echo "-----------------------------------------"
fi

cat ../pass/_fun3_parser.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_fun3_parser.res
diff ../pass/_fun3_parser.out ../pass/_fun3_parser.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "| PARSER: FUNCTION THREE TEST PASSED    |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "| PARSER: FUNCTION THREE TEST FAILED    |"
  echo "-----------------------------------------"
fi

cat ../pass/_simple_matrix.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_simple_matrix.res
diff ../pass/_simple_matrix.out ../pass/_simple_matrix.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "| PARSER: SIMPLE MATRIX TEST PASSED     |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "| PARSER: SIMPLE MATRIX TEST FAILED     |"
  echo "-----------------------------------------"
fi

cat ../pass/_complicated_matrix.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_complicated_matrix.res
diff ../pass/_complicated_matrix.out ../pass/_complicated_matrix.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "|PARSER: COMPLICATED MATRIX TEST PASSED |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "|PARSER: COMPLICATED MATRIX TEST FAILED |"
  echo "-----------------------------------------"
fi

cat ../fail/_illegal_binop.test | menhir --interpret --interpret-show-cst parser.mly > ../fail/_illegal_binop.res
diff ../fail/_illegal_binop.out ../fail/_illegal_binop.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "|    PARSER: ILEGAL BINOP TEST PASSED   |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "|    PARSER: ILEGAL BINOP TEST FAILED   |"
  echo "-----------------------------------------"
fi

cat ../fail/_malformed_fdecl.test | menhir --interpret --interpret-show-cst parser.mly > ../fail/_malformed_fdecl.res
diff ../fail/_malformed_fdecl.out ../fail/_malformed_fdecl.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "|  PARSER: MALFORMED FDECL TEST PASSED  |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "|  PARSER: MALFORMED FDECL TEST FAILED  |"
  echo "-----------------------------------------"
fi

cat ../fail/_malformed_matrix_decl.test | menhir --interpret --interpret-show-cst parser.mly > ../fail/_malformed_matrix_decl.res
diff ../fail/_malformed_matrix_decl.out ../fail/_malformed_matrix_decl.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "|  PARSER: MALFORMED MDECL TEST PASSED  |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "|  PARSER: MALFORMED MDECL TEST FAILED  |"
  echo "-----------------------------------------"
fi

cat ../fail/_vdecl_without_semi.test | menhir --interpret --interpret-show-cst parser.mly > ../fail/_vdecl_without_semi.res
diff ../fail/_vdecl_without_semi.out ../fail/_vdecl_without_semi.res > /dev/null
if [ $? = 0 ]; then
  echo -e "\e[0;32m"
  echo "-----------------------------------------"
  echo "|PARSER: VDECL WITHOUT SEMI TEST PASSED |"
  echo "-----------------------------------------"
else
  echo -e "\e[0;31m"
  echo "-----------------------------------------"
  echo "|PARSER: VDECL WITHOUT SEMI TEST FAILED |"
  echo "-----------------------------------------"
fi

cat ../pass/_main_return.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_main_return.res
cat ../pass/_fun_float.test | menhir --interpret --interpret-show-cst parser.mly > ../pass/_fun_float.res